      ******************************************************************
      ** Simple COBOL program that performs integer arithmetic        **
      ******************************************************************
       IDENTIFICATION DIVISION.
        PROGRAM-ID. 'SMPLCALC'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77 MSG-NUMERIC-OVERFLOW PIC X(25)
           VALUE 'Numeric overflow occurred'.
       77 MSG-SUCCESSFUL PIC X(22)
           VALUE 'Completed successfully'.
       LINKAGE SECTION.
      * Input/Output data structure
       01 SMPLCALC-INTERFACE.
          02 SI-OPERAND-1 PIC S9(9) COMP-5.
          02 SI-OPERAND-2 PIC S9(9) COMP-5.
          02 SI-OPERATION PIC X.
             88 DO-ADD VALUE '+'.
             88 DO-SUB VALUE '-'.
             88 DO-MUL VALUE '*'.
          02 SI-RESULT PIC S9(18) COMP-5.
          02 SI-RESULT-MESSAGE PIC X(128).
       PROCEDURE DIVISION USING
           BY REFERENCE SMPLCALC-INTERFACE.
       MAINLINE SECTION.
      * Perform requested arithmetic
           INITIALIZE SI-RESULT SI-RESULT-MESSAGE
           EVALUATE TRUE
             WHEN DO-ADD
               COMPUTE SI-RESULT = SI-OPERAND-1 + SI-OPERAND-2
                 ON SIZE ERROR
                   PERFORM HANDLE-SIZE-ERROR
               END-COMPUTE
             WHEN DO-SUB
               COMPUTE SI-RESULT = SI-OPERAND-1 - SI-OPERAND-2
                 ON SIZE ERROR
                   PERFORM HANDLE-SIZE-ERROR
               END-COMPUTE
             WHEN DO-MUL
               COMPUTE SI-RESULT = SI-OPERAND-1 * SI-OPERAND-2
                 ON SIZE ERROR
                   PERFORM HANDLE-SIZE-ERROR
               END-COMPUTE
           END-EVALUATE
      * Successful return
           MOVE MSG-SUCCESSFUL TO SI-RESULT-MESSAGE
           MOVE 2 TO RETURN-CODE
           GOBACK
           .
      ******************************************************************
      ** Handle numeric overflow and end the program                  **
      ******************************************************************
       HANDLE-SIZE-ERROR.
           MOVE MSG-NUMERIC-OVERFLOW TO SI-RESULT-MESSAGE
           MOVE 16 TO RETURN-CODE
           GOBACK
           .
       END PROGRAM 'SMPLCALC'.
